Subject: Re: [PATCH] The MPC83xx family doesn't support performance monitor instructions

From: Jerry Van Baren <[email-masked]>
Date: Thu, 06 Mar 2008 19:51:37 -0500

Kumar Gala wrote:
> On Mar 5, 2008, at 6:33 PM, Gerald Van Baren wrote:
> 
>> "Errata to MPC8349EA PowerQUICC[tm] II Pro Integrated Host Processor  
>> Family
>> Reference Manual, Rev. 1" (Freescale)
>>
>> Signed-off-by: Gerald Van Baren <[email-masked]>
>> ---
>>
>> Hi Kumar,
>>
>> Please apply this fix to 2.6.25rc4 if possible.  Without this
>> patch, the PPC_83xx family configuration is broken (will not compile).
> 
> What's the compile issue?  Some of the 83xx family have perf mon so we  
> need to fix the compile issue.
> 
> - k

Hi Kumar,

The mpc8360 and mpc8349 do not have a perfmon register (I don't find it 
at all in the MPC8360RM and the mpc8349 errata I referenced says the 
MPC8349RM is in error).

The result is that the assembler dies with an error.  If the assembler 
didn't die with an error, I presume the kernel would since it is an 
invalid SPR.

   CC      arch/powerpc/kernel/pmc.o
{standard input}: Assembler messages:
{standard input}:7: Error: Unrecognized opcode: `mfpmr'
{standard input}:11: Error: Unrecognized opcode: `mtpmr'
make[1]: *** [arch/powerpc/kernel/pmc.o] Error 1
make: *** [arch/powerpc/kernel] Error 2

This is using ELDK4.1 (also 4.2rc) using the ppc_6xx- version of the 
compiler (which symlinks to powerpc-linux-gcc).

If some of the mpc83xx processors have perfmon registers, we need a more 
granular way of selecting the CONFIG_FSL_EMB_PERFMON option (or a Plan 
B, but I don't know what Plan B would be).

Best regards,
gvb